diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java
index dcd58660a..35af4f5ae 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java
@@ -262,6 +262,10 @@ public abstract class ScreenContainerAbstract extends Screen {
         if (!this.mc.thePlayer.getGamemode().hasBlockConsumption()) {
             // Duplicate items with middle mouse button
             if (buttonNum == 2) {
+                if (GameSettings.ENABLE_ITEM_DRAGGING.value) {
+                    this.itemDragHandler.mouseEvent(mx, my, buttonNum, true);
+                    return;
+                }
                 Slot slot = this.inventorySlots.getSlot(getSlotId(mx, my));
                 if (slot != null) {
                     if (slot.getItemStack() == null) {
diff --git a/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java
index a9a0ac06d..f3594f92a 100644
--- a/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java
+++ b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java
@@ -58,6 +58,9 @@ public abstract class PlayerController {
             return;
         }
 
+        final @NotNull Block<?> mineBlock = world.getBlockType(tilePos);
+        if (!mineBlock.canCollideCheck(world.getBlockData(tilePos), false)) return;
+
         if (!player.getGamemode().hasBlockBreakingAnimation()) {
             this.swingItem(true);
 
@@ -71,7 +74,6 @@ public abstract class PlayerController {
             return;
         }
 
-        final @NotNull Block<?> mineBlock = world.getBlockType(tilePos);
         final float mineStrength = mineBlock.getStrength(world, tilePos, side, player);
 
         if (mineStrength < 1.0f) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
index fd5b5ea7f..a7ea30810 100644
--- a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
@@ -22,7 +22,6 @@ import org.joml.Matrix4f;
 import org.joml.Vector3d;
 import org.joml.Vector3dc;
 import org.joml.primitives.AABBd;
-import org.joml.primitives.AABBdc;
 import org.lwjgl.input.Mouse;
 
 import net.minecraft.client.Minecraft;
@@ -47,10 +46,12 @@ import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.item.IPlaceable;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.debug.Debug;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.helper.Time;
 import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.world.World;
@@ -127,23 +128,22 @@ public class WorldRenderer {
     }
 
     public void getMouseOver(float partialTicks) {
-        if (this.mc.activeCamera == null) {
-            return;
-        }
-        if (this.mc.currentWorld == null) {
-            return;
-        }
+        if (this.mc.activeCamera == null) return;
+        if (this.mc.currentWorld == null) return;
 
         final double blockReach = this.mc.thePlayer.getGamemode().getBlockReachDistance();
         final double entityReach = this.mc.thePlayer.getGamemode().getEntityReachDistance();
 
-        Vector3dc pos1 = this.mc.thePlayer.getPosition(partialTicks, true);
-        Vector3dc look = this.mc.thePlayer.getViewVector(partialTicks);
+        final Vector3dc pos1 = this.mc.thePlayer.getPosition(partialTicks, true);
+        final Vector3dc look = this.mc.thePlayer.getViewVector(partialTicks);
         assert look != null;
-        Vector3dc pos2 = pos1.add(look.x() * blockReach, look.y() * blockReach, look.z() * blockReach, new Vector3d());
+        final Vector3dc pos2 = new Vector3d(look).mul(blockReach).add(pos1);
+        
+        final var playerItem = this.mc.thePlayer.inventory.getCurrentItem();
+        final boolean interactsWithFluid = playerItem != null && playerItem.interactsWithFluid();
 
         // Raytrace blocks
-        this.mc.objectMouseOver = this.mc.thePlayer.rayCast(blockReach, partialTicks, false, false, true);
+        this.mc.objectMouseOver = this.mc.thePlayer.rayCast(blockReach, partialTicks, interactsWithFluid, false, true);
 //		mc.objectMouseOver = mc.currentWorld.checkBlockCollisionBetweenPoints(pos1, pos2, false, false, true);
 
         // Calculate again because block raytrace changes the values
@@ -151,28 +151,32 @@ public class WorldRenderer {
 //		look = mc.thePlayer.getViewVector(partialTicks);
 //		pos2 = pos1.add(look.x * entityReach, look.y * entityReach, look.z * entityReach);
 
-        double hitBlockDistance = 1000.0;
-        if (this.mc.objectMouseOver != null) {
-            hitBlockDistance = pos1.distance(this.mc.objectMouseOver.location);
-        }
+        final double hitBlockDistance = (this.mc.objectMouseOver != null)
+            ? pos1.distance(this.mc.objectMouseOver.location)
+            : Double.POSITIVE_INFINITY;
 
         this.pointedEntity = null;
-        float expand = 1.0f;
-        AABBd entitySearchBox = MathHelper.aabbExpand(this.mc.thePlayer.bb, look.x() * entityReach, look.y() * entityReach, look.z() * entityReach, new AABBd());
+        
+        final float expand = 1.0f;
+        final AABBd entitySearchBox = MathHelper.aabbExpand(this.mc.thePlayer.bb, look.x() * entityReach, look.y() * entityReach, look.z() * entityReach, new AABBd());
         MathHelper.aabbGrow(entitySearchBox, expand, expand, expand, entitySearchBox);
-
-        List<Entity> entities = this.mc.currentWorld.getEntitiesWithinAABBExcludingEntity(this.mc.thePlayer, entitySearchBox);
-
+        
         // Search for the closest hit entity
         double pointedEntityDistance = 0.0;
+
+        final var entities = this.mc.currentWorld.getEntitiesWithinAABBExcludingEntity(this.mc.thePlayer, entitySearchBox);
+        final AABBd hitBox = new AABBd();
         for (int i = 0; i < entities.size(); i++) {
-            Entity entity = entities.get(i);
-            if (!entity.isSelectable()) {
-                continue;
+            final Entity entity = entities.get(i);
+
+            if (playerItem != null) {
+                if (!playerItem.interactsWithEntity(entity)) continue;
+            } else {
+                if (!entity.isSelectable()) continue;
             }
 
-            float hitRadius = entity == this.mc.thePlayer.vehicle ? 0 : entity.getPickRadius();
-            AABBdc hitBox = MathHelper.aabbGrow(entity.bb, hitRadius, hitRadius, hitRadius, new AABBd());
+            final float hitRadius = entity == this.mc.thePlayer.vehicle ? 0 : entity.getPickRadius();
+            MathHelper.aabbGrow(entity.bb, hitRadius, hitRadius, hitRadius, hitBox);
 
             if (hitBox.containsPoint(pos1)) {
                 this.pointedEntity = entity;
@@ -180,12 +184,10 @@ public class WorldRenderer {
                 continue;
             }
 
-            HitResult hitResult = MathHelper.aabbClip(hitBox, pos1, pos2);
-            if (hitResult == null) {
-                continue;
-            }
+            final HitResult hitResult = MathHelper.aabbClip(hitBox, pos1, pos2);
+            if (hitResult == null) continue;
 
-            double entityDistance = pos1.distance(hitResult.location);
+            final double entityDistance = pos1.distance(hitResult.location);
             if (this.pointedEntity == null || entityDistance < pointedEntityDistance) {
                 this.pointedEntity = entity;
                 pointedEntityDistance = entityDistance;
@@ -207,7 +209,9 @@ public class WorldRenderer {
         if (!GameSettings.EASY_BRIDGE.value) return;
         if (!this.mc.thePlayer.onGround) return;
         if (Direction.getLockable(this.mc.thePlayer) != Direction.DOWN) return;
-        if (this.mc.thePlayer.inventory.getCurrentItem() == null) return;
+        final var item = this.mc.thePlayer.inventory.getCurrentItem();
+        if (item == null) return;
+        if (!(item.getItem() instanceof IPlaceable placeable)) return;
 
         this.mc.bridgePos.set(
             MathHelper.floor(this.mc.thePlayer.x),
@@ -215,7 +219,11 @@ public class WorldRenderer {
             MathHelper.floor(this.mc.thePlayer.z)
         );
 
-        this.mc.canBridge = this.mc.thePlayer.world.canPlaceInsideBlock(this.mc.bridgePos);
+        if (!placeable.canPlaceDirectlyAtPosition(
+            item, this.mc.currentWorld, this.mc.thePlayer, this.mc.bridgePos, Side.TOP, 
+            0.5, 0.5)) return;
+        
+        this.mc.canBridge = true;
     }
 
     private float getFOVModifier(float partialTick, boolean isModifiedByFOV) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
index 271270fd2..be6db2908 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
@@ -76,7 +76,6 @@ public class MobRendererPlayer extends MobRendererBipedArmored<Player> {
             final TessellatorGeneral tessellator = GLRenderer.getTessellator();
             TextureRegistry.worldAtlas.bind();
             GLRenderer.pushFrame();
-            Lighting.disable();
 
             GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
             GLRenderer.enableState(State.BLEND);
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBucket.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBucket.java
index 6bd95d81a..b54bf5588 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBucket.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBucket.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.render.item.model;
 
+import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.entity.Entity;
@@ -7,6 +8,7 @@ import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemBucket;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.collection.NamespaceID;
+import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -17,12 +19,21 @@ import java.util.Set;
 public abstract class ItemModelBucket extends ItemModelStandard {
 
     protected final Map<NamespaceID, IconCoordinate[]> bucketIcons = new HashMap<>();
+    private final Map<String, IconCoordinate[]> textureIconCache = new HashMap<>();
+
+    protected String iconNamespace;
+    protected String iconPrefix;
+    protected int iconMaxCharges;
 
     public ItemModelBucket(@NotNull Item item, boolean defaultTextureLookup) {
         super(item, defaultTextureLookup);
     }
 
     protected void initializeIcons(@NotNull String namespace, @NotNull String prefix, int maxCharges, @NotNull Set<@NotNull NamespaceID> validStates) {
+        this.iconNamespace = namespace;
+        this.iconPrefix = prefix;
+        this.iconMaxCharges = maxCharges;
+
         IconCoordinate[] emptyArray = new IconCoordinate[1];
         emptyArray[0] = TextureRegistry.getTexture(namespace + ":item/" + prefix + "/empty");
         this.bucketIcons.put(ItemBucket.STATE_EMPTY, emptyArray);
@@ -41,6 +52,17 @@ public abstract class ItemModelBucket extends ItemModelStandard {
         }
     }
 
+    private @NotNull IconCoordinate[] getChargeIcons(final @NotNull String textureStateName, final int maxCharges) {
+        return textureIconCache.computeIfAbsent(textureStateName, name -> {
+            IconCoordinate[] chargesArray = new IconCoordinate[maxCharges + 1];
+            for (int c = 1; c <= maxCharges; c++) {
+                String path = iconNamespace + ":item/" + iconPrefix + "/" + name + "_" + c;
+                chargesArray[c] = TextureRegistry.getTexture(path);
+            }
+            return chargesArray;
+        });
+    }
+
     @Override
     public @NotNull IconCoordinate getIcon(@Nullable Entity entity, @NotNull ItemStack itemStack) {
         NamespaceID state = ItemBucket.getState(itemStack);
@@ -57,7 +79,24 @@ public abstract class ItemModelBucket extends ItemModelStandard {
         }
 
         charges = Math.max(0, Math.min(charges, maxForThisBucket));
-        IconCoordinate[] iconsForState = bucketIcons.get(state);
+
+        if (ItemBucket.STATE_EMPTY.equals(state)) {
+            IconCoordinate[] emptyIcons = bucketIcons.get(ItemBucket.STATE_EMPTY);
+            if (emptyIcons != null && charges < emptyIcons.length) {
+                IconCoordinate emptyIcon = emptyIcons[charges];
+                if (emptyIcon != null) {
+                    return emptyIcon;
+                }
+            }
+            return super.getIcon(entity, itemStack);
+        }
+
+        final World world = entity != null ? entity.world : Minecraft.getMinecraft().currentWorld;
+        final String textureStateName = ItemBucket.getTextureStateName(entity, world, itemStack);
+        final String defaultTextureStateName = ItemBucket.getStateName(state);
+        IconCoordinate[] iconsForState = textureStateName.equals(defaultTextureStateName)
+            ? bucketIcons.get(state)
+            : getChargeIcons(textureStateName, maxForThisBucket);
 
         if (iconsForState == null || charges >= iconsForState.length) {
             return super.getIcon(entity, itemStack);
@@ -66,4 +105,4 @@ public abstract class ItemModelBucket extends ItemModelStandard {
         IconCoordinate icon = iconsForState[charges];
         return (icon != null) ? icon : super.getIcon(entity, itemStack);
     }
-}
\ No newline at end of file
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
index 87b3af8b0..9194db182 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
@@ -10,15 +10,15 @@ import net.minecraft.core.item.block.ItemBlock;
 import org.useless.dragonfly.DisplayPos;
 
 public class ItemModelDispatcher extends Dispatcher<Item, ItemModel> {
-    protected static final DisplayPos HANDHELD_FIRST_PERSON_RIGHT_HAND = new DisplayPos(1.13f/16f, 3.2f/16f, 1.13f/16f, 0, -90, 25, 0.68f, 0.68f, 0.68f);
-    protected static final DisplayPos HANDHELD_FIRST_PERSON_LEFT_HAND = new DisplayPos(1.13f/16f, 3.2f/16f, 1.13f/16f, 0, 90, -25, 0.68f, 0.68f, 0.68f);
-    protected static final DisplayPos HANDHELD_THIRD_PERSON_RIGHT_HAND = new DisplayPos(0, 4.0f/16f, 0.5f/16f, 0, -90, 55, 0.85f, 0.85f, 0.85f);
-    protected static final DisplayPos HANDHELD_THIRD_PERSON_LEFT_HAND = new DisplayPos(0, 4.0f/16f, 0.5f/16f, 0,  90, -55, 0.85f, 0.85f, 0.85f);
-
-    protected static final DisplayPos HANDHELD_ROD_FIRST_PERSON_RIGHT_HAND = new DisplayPos(0/16f, 1.6f/16f, 0.8f/16f, 0, 90, 25, 0.68f, 0.68f, 0.68f);
-    protected static final DisplayPos HANDHELD_ROD_FIRST_PERSON_LEFT_HAND = new DisplayPos(0/16f, 1.6f/16f, 0.8f/16f, 0, -90, -25, 0.68f, 0.68f, 0.68f);
-    protected static final DisplayPos HANDHELD_ROD_THIRD_PERSON_RIGHT_HAND = new DisplayPos(0, 4.0f/16f, 2.5f/16f, 0, 90, 55, 0.85f, 0.85f, 0.85f);
-    protected static final DisplayPos HANDHELD_ROD_THIRD_PERSON_LEFT_HAND = new DisplayPos(0, 4.0f/16f, 2.5f/16f, 0,  -90, -55, 0.85f, 0.85f, 0.85f);
+    public static final DisplayPos HANDHELD_FIRST_PERSON_RIGHT_HAND = new DisplayPos(1.13f/16f, 3.2f/16f, 1.13f/16f, 0, -90, 25, 0.68f, 0.68f, 0.68f);
+    public static final DisplayPos HANDHELD_FIRST_PERSON_LEFT_HAND = new DisplayPos(1.13f/16f, 3.2f/16f, 1.13f/16f, 0, 90, -25, 0.68f, 0.68f, 0.68f);
+    public static final DisplayPos HANDHELD_THIRD_PERSON_RIGHT_HAND = new DisplayPos(0, 4.0f/16f, 0.5f/16f, 0, -90, 55, 0.85f, 0.85f, 0.85f);
+    public static final DisplayPos HANDHELD_THIRD_PERSON_LEFT_HAND = new DisplayPos(0, 4.0f/16f, 0.5f/16f, 0,  90, -55, 0.85f, 0.85f, 0.85f);
+
+    public static final DisplayPos HANDHELD_ROD_FIRST_PERSON_RIGHT_HAND = new DisplayPos(0/16f, 1.6f/16f, 0.8f/16f, 0, 90, 25, 0.68f, 0.68f, 0.68f);
+    public static final DisplayPos HANDHELD_ROD_FIRST_PERSON_LEFT_HAND = new DisplayPos(0/16f, 1.6f/16f, 0.8f/16f, 0, -90, -25, 0.68f, 0.68f, 0.68f);
+    public static final DisplayPos HANDHELD_ROD_THIRD_PERSON_RIGHT_HAND = new DisplayPos(0, 4.0f/16f, 2.5f/16f, 0, 90, 55, 0.85f, 0.85f, 0.85f);
+    public static final DisplayPos HANDHELD_ROD_THIRD_PERSON_LEFT_HAND = new DisplayPos(0, 4.0f/16f, 2.5f/16f, 0,  -90, -55, 0.85f, 0.85f, 0.85f);
 
     private static ItemModelDispatcher instance = new ItemModelDispatcher();
     public static final ItemModel emptyModel = new ItemModelNone();
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererJarButterfly.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererJarButterfly.java
index c813ce39b..0b5f21272 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererJarButterfly.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererJarButterfly.java
@@ -13,6 +13,6 @@ public class TileEntityRendererJarButterfly extends TileEntityRenderer<TileEntit
         boolean hanging = (meta & BlockLogicJarButterfly.MASK_HANGING) != 0;
         MobRendererButterfly.drawButterfly(tessellator, tileEntity.ticksRan, 0.70f, 0,
             x + 0.5, y + (hanging ? 6/16f : 0) - 0.125 + MathHelper.sin((tileEntity.ticksRan + partialTick)/20) * (0.0625), z + 0.5,
-            partialTick, this.renderDispatcher.textureManager, "/assets/minecraft/textures/entity/butterfly/" + tileEntity.color.name + "/0_0.png");
+            partialTick, this.renderDispatcher.textureManager, "/assets/minecraft/textures/entity/butterfly/" + tileEntity.color.name() + "/0_0.png");
     }
 }
diff --git a/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/BlockModelMojangData.java b/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/BlockModelMojangData.java
index 2e0aec760..76aa73368 100644
--- a/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/BlockModelMojangData.java
+++ b/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/BlockModelMojangData.java
@@ -129,7 +129,10 @@ public class BlockModelMojangData implements BlockModelData {
                 this.renderLayer = (parentData.renderLayer != null && renderLayer == null) ? parentData.renderLayer : renderLayer;
 
                 if (parentData.displayPositions != null) this.displayPositions.putAll(parentData.displayPositions);
-                if (displayPositions != null) this.displayPositions.putAll(displayPositions);
+                if (displayPositions != null) {
+                    this.displayPositions.putAll(displayPositions);
+                    generateOtherHandPoses(displayPositions);
+                }
                 if (parentData.textures != null) this.textures.putAll(parentData.textures);
                 if (textures != null) this.textures.putAll(textures);
                 if (parentData.particleIndices != null) this.particleIndices.putAll(parentData.particleIndices);
@@ -137,6 +140,7 @@ public class BlockModelMojangData implements BlockModelData {
             } else {
                 this.ambientOcclusion = ambientOcclusion == null ? DEFAULT_AMBIENT_OCCLUSION : ambientOcclusion;
                 this.displayPositions = displayPositions;
+                if (displayPositions != null) generateOtherHandPoses(displayPositions);
                 this.particleIndices = particleIndices;
                 this.renderLayer = renderLayer;
                 this.textures = textures;
@@ -145,12 +149,25 @@ public class BlockModelMojangData implements BlockModelData {
         } else {
             this.ambientOcclusion = ambientOcclusion == null ? DEFAULT_AMBIENT_OCCLUSION : ambientOcclusion;
             this.displayPositions = displayPositions;
+            if (displayPositions != null) generateOtherHandPoses(displayPositions);
             this.particleIndices = particleIndices;
             this.renderLayer = renderLayer;
             this.textures = textures;
             this.elements = elements;
         }
+    }
 
+    // Mojang will automatically transfer right handed overrides to the left hand, even if the parent model has an existing definition for them
+    private void generateOtherHandPoses(@NotNull Map<String, DisplayPos> overridePoses) {
+        assert this.displayPositions != null : "should only be called when this.displayPositions definitely exists!";
+        if (overridePoses.containsKey(DisplayPos.FIRST_PERSON_RIGHT_HAND) && !overridePoses.containsKey(DisplayPos.FIRST_PERSON_LEFT_HAND)) {
+            var right = overridePoses.get(DisplayPos.FIRST_PERSON_RIGHT_HAND);
+            this.displayPositions.put(DisplayPos.FIRST_PERSON_LEFT_HAND, right);
+        }
+        if (overridePoses.containsKey(DisplayPos.THIRD_PERSON_RIGHT_HAND) && !overridePoses.containsKey(DisplayPos.THIRD_PERSON_LEFT_HAND)) {
+            var right = overridePoses.get(DisplayPos.THIRD_PERSON_RIGHT_HAND);
+            this.displayPositions.put(DisplayPos.THIRD_PERSON_LEFT_HAND, right);
+        }
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicGrowthRubyglass.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicGrowthRubyglass.java
index 1c9369df2..3045ada08 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicGrowthRubyglass.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicGrowthRubyglass.java
@@ -211,16 +211,17 @@ public class BlockLogicGrowthRubyglass extends BlockLogic {
 
 	@Override
 	public ItemStack @Nullable [] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity) {
-		if (dropCause != EnumDropCause.SILK_TOUCH) {
-			return null;
-		}
-
-		int shape = data & SHAPE_MASK;
-
-		if (shape == STATE_BOTTOM) {
-			return new ItemStack[] { new ItemStack(this.block, 2) };
-		}
-
-		return new ItemStack[] { new ItemStack(this.block, 1) };
-	}
+        if (dropCause == EnumDropCause.PICK_BLOCK) {
+            return new ItemStack[]{this.block.getDefaultStack()};
+        } else if (dropCause == EnumDropCause.SILK_TOUCH) {
+            int shape = data & SHAPE_MASK;
+
+            if (shape == STATE_BOTTOM) {
+                return new ItemStack[]{new ItemStack(this.block, 2)};
+            }
+
+            return new ItemStack[]{new ItemStack(this.block, 1)};
+        }
+        return null;
+    }
 }
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicJarButterfly.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicJarButterfly.java
index 5e9e63706..44a97bf18 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicJarButterfly.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicJarButterfly.java
@@ -135,7 +135,7 @@ public class BlockLogicJarButterfly extends BlockLogic implements ISupportable {
         }
         if (!world.isClientSide) {
             MobButterfly entity = new MobButterfly(world);
-            entity.setColor(this.color.id);
+            entity.setColor(this.color.id());
             entity.setPos(tilePos.x() + 0.5f + (world.rand.nextFloat() - 0.5f) * 0.5f, tilePos.y() + world.rand.nextFloat() * 0.5f, tilePos.z() + 0.5f + (world.rand.nextFloat() - 0.5f) * 0.5f);
             world.entityJoinedWorld(entity);
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerAsh.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerAsh.java
index b09358de3..af63cfeea 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerAsh.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerAsh.java
@@ -17,7 +17,7 @@ import org.jetbrains.annotations.Nullable;
 public class BlockLogicLayerAsh extends BlockLogicLayerSupportable
 {
 
-    public BlockLogicLayerAsh(Block<? extends BlockLogicLayerBase> block, Block<?> fullBlock, Material material)
+    public BlockLogicLayerAsh(@NotNull Block<? extends BlockLogicLayerBase> block, @NotNull Block<?> fullBlock, @NotNull Material material)
     {
         super(block, fullBlock, material);
         setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.125F, 1.0F);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerBase.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerBase.java
index a0d8de9dc..628d9c951 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerBase.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerBase.java
@@ -19,7 +19,7 @@ public abstract class BlockLogicLayerBase extends BlockLogic
     public final @Nullable Block<?> fullBlock;
     public static final int MASK_HEIGHT = 0b111;
 	
-	public BlockLogicLayerBase(@NotNull Block<? extends BlockLogicLayerBase> block, @Nullable Block<?> fullBlock, @NotNull Material material)
+	public BlockLogicLayerBase(@NotNull Block<? extends BlockLogicLayerBase> block, @NotNull Block<?> fullBlock, @NotNull Material material)
     {
         super(block, material);
         setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.125F, 1.0F);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerLeaves.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerLeaves.java
index b01bf518f..c401bb588 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerLeaves.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerLeaves.java
@@ -19,7 +19,7 @@ import java.util.Random;
 public class BlockLogicLayerLeaves extends BlockLogicLayerSupportable {
     public static final int MASK_PERMANENT = 0b1000_0000;
 
-    public BlockLogicLayerLeaves(Block<? extends BlockLogicLayerLeaves> block, Block<?> fullBlock, Material material) {
+    public BlockLogicLayerLeaves(@NotNull Block<? extends BlockLogicLayerLeaves> block, @NotNull Block<?> fullBlock, @NotNull Material material) {
         super(block, fullBlock, material);
         setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.125F, 1.0F);
         block.setTicking(true);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSlate.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSlate.java
index e8c2681f2..6bca23523 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSlate.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSlate.java
@@ -11,7 +11,7 @@ import org.jetbrains.annotations.Nullable;
 
 public class BlockLogicLayerSlate extends BlockLogicLayerBase
 {
-	public BlockLogicLayerSlate(@NotNull Block<? extends BlockLogicLayerBase> block, @Nullable Block<?> fullBlock, @NotNull Material material) {
+	public BlockLogicLayerSlate(@NotNull Block<? extends BlockLogicLayerBase> block, @NotNull Block<?> fullBlock, @NotNull Material material) {
 		super(block, fullBlock, material);
 	}
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSnow.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSnow.java
index b98471617..cf5f41b1a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSnow.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSnow.java
@@ -22,7 +22,7 @@ import java.util.Random;
 
 public class BlockLogicLayerSnow extends BlockLogicLayerSupportable {
 
-    public BlockLogicLayerSnow(@NotNull Block<? extends BlockLogicLayerBase> block, @Nullable Block<?> fullBlock, @NotNull Material material) {
+    public BlockLogicLayerSnow(@NotNull Block<? extends BlockLogicLayerBase> block, @NotNull Block<?> fullBlock, @NotNull Material material) {
         super(block, fullBlock, material);
         setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.125F, 1.0F);
         block.setTicking(true);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSupportable.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSupportable.java
index 23d242b52..6a98f27dc 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSupportable.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSupportable.java
@@ -9,10 +9,9 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
-import org.jetbrains.annotations.Nullable;
 
 public abstract class BlockLogicLayerSupportable extends BlockLogicLayerBase implements ISupportable {
-	public BlockLogicLayerSupportable(@NotNull Block<? extends BlockLogicLayerBase> block, @Nullable Block<?> fullBlock, @NotNull Material material) {
+	public BlockLogicLayerSupportable(@NotNull Block<? extends BlockLogicLayerBase> block, @NotNull Block<?> fullBlock, @NotNull Material material) {
         super(block, fullBlock, material);
     }
 
